// Copyright (C) 2002 Christian Weis

#pragma once

// guards func
#define GUARD(FUNC) \
		{ \
			static const char* const __pfunc__ = #FUNC; \
			try \
			{ \

// unguard func
#define UNGUARD \
			} \
			catch (const char *pe) \
			{ \
				apiHandleErr (pe, __pfunc__); \
				THROW (0) \
			} \
			catch (...) \
			{ \
				apiHandleErr ("Unexpected Exception!", __pfunc__); \
				THROW (0) \
			} \
		} \

// throws err msg
#define THROW(MSG) {throw (const char*) (MSG);}

// protected code
#define PROTECTED(CODE) {try {CODE} catch (...) {}}

// func guarding in time critical funcs
#ifdef _DEBUG
#define GUARD_FAST(FUNC) GUARD (FUNC)
#define UNGUARD_FAST UNGUARD
#else
#define GUARD_FAST(FUNC) {
#define UNGUARD_FAST }
#endif

// err handler api
extern void apiHandleErr (const char *pe, const char *pfunc);
extern void apiShowErr (const char *pcap = 0);
extern void apiDisableErrHandler ();